#ifndef __GDIPUTIL_H__
#define __GDIPUTIL_H__

#include <gdiplus.h>

#pragma comment(lib, "gdiplus.lib") 

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;

void Init_Gdip();
bool Draw_Image(HWND hWnd, HDC hDC, char *filename);
void Term_Gdip();

void Init_Gdip()
{
	GdiplusStartup(&gdiToken,&gdiSI,NULL);
}// Init_Gdip

bool Draw_Image(HWND hWnd, HDC hDC, char *filename)
{
	char ext[_MAX_EXT];
	_splitpath(filename, NULL, NULL, NULL, ext);
	if(!stricmp(ext, ".ico") || !stricmp(ext, ".cur")){
		return false;
	}
	
	Graphics	g(hDC);
	WCHAR		wfname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,filename,-1,wfname,sizeof(wfname));
	Bitmap		Bmp(wfname, TRUE);
	if(Ok == Bmp.GetLastStatus()){
		int			wdh1,hgt1,wdh2,hgt2;
		RECT		rc;
		GetClientRect(hWnd, &rc);
		wdh1 = Bmp.GetWidth();
		hgt1 = Bmp.GetHeight();
		if(wdh1 > hgt1){
			if(wdh1 > rc.bottom){
				wdh2 = rc.bottom;
				hgt2 = rc.bottom * hgt1 / wdh1;
			}
			else{
				wdh2 = wdh1;
				hgt2 = hgt1;
			}
		}
		else{
			if(hgt1 > rc.bottom){
				wdh2 = rc.bottom * wdh1 / hgt1;
				hgt2 = rc.bottom;
			}
			else{
				wdh2 = wdh1;
				hgt2 = hgt1;
			}
		}
		POINT		pos;
		pos.x = (rc.bottom - wdh2) / 2;
		pos.y = (rc.bottom - hgt2) / 2;
		g.DrawImage(&Bmp, pos.x, pos.y, wdh2, hgt2);
		return true;
	}
	return false;
}// Draw_Image

void Term_Gdip()
{
	GdiplusShutdown(gdiToken);
}// Term_Gdip

#endif // __GDIPUTIL_H__
