#ifndef __SHELLUTIL_H__
#define __SHELLUTIL_H__

#include <stdio.h>
#include <shlobj.h>

char	g_path[MAX_PATH] = "";

int 	CALLBACK ProcBrowse(HWND hWnd, UINT uMsg, LPARAM lp, LPARAM pData);
bool	Set_Dir(HWND hWnd);
void	_SHFree(void *p);
HRESULT CreateShortCut(LPCSTR pszShortcutFile, LPSTR pszLink, LPSTR pszDesc);
void	Create_ShortcutOnDesktop(char *file_name);

// tH_[I_CAO vV[W
int CALLBACK ProcBrowse(HWND hWnd, UINT uMsg, LPARAM lp, LPARAM pData)
{
	TCHAR szDir[MAX_PATH];

	switch(uMsg) {
		case BFFM_INITIALIZED:
			{
				if (strcmp(g_path,"")) {
					// WParam is TRUE since you are passing a path.
					// It would be FALSE if you were passing a pidl.
					SendMessage(hWnd,BFFM_SETSELECTION,TRUE,(LPARAM)g_path);
				}
				break;
			}
		case BFFM_SELCHANGED:
			{
				// Set the status window to the currently selected path.
				if (SHGetPathFromIDList((LPITEMIDLIST) lp ,szDir)) {
					SendMessage(hWnd,BFFM_SETSTATUSTEXT,0,(LPARAM)szDir);
				}
				break;
			}
		default:
			break;
	}
	return 0;
}// ProcBrowse

bool Set_Dir(HWND hWnd)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	char ach[MAX_PATH];
	
	bi.hwndOwner	  = hWnd;
	bi.pidlRoot 	  = NULL;
	bi.pszDisplayName = ach;
	bi.lpszTitle	  = "tH_[IĂ";
	bi.ulFlags		  = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	bi.lpfn 		  = ProcBrowse;
	bi.lParam		  = 0;
	bi.iImage		  = 0;
	pidl = SHBrowseForFolder(&bi);
	if (pidl)
	{
		SHGetPathFromIDList(pidl, ach);
		strcpy(g_path, ach);
		_SHFree(pidl);
		return true;
	}
	return false;
}// Set_Dir

void _SHFree(void *p)
{
	IMalloc *pm;
	SHGetMalloc(&pm);
	if (pm)
	{
		pm->Free(p);
		pm->Release();
	}
}// _SHFree

HRESULT CreateShortCut(LPCSTR pszShortcutFile, LPSTR pszLink, LPSTR pszDesc)
{
	HRESULT 	hres;
	IShellLink* psl;
	
	// Get a pointer to the IShellLink interface.
	hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void **) &psl);
	if (SUCCEEDED(hres))
	{
		IPersistFile* ppf;
		// Query IShellLink for the IPersistFile interface for 
		// saving the shell link in persistent storage.
		hres = psl->QueryInterface(IID_IPersistFile, (void **) &ppf);
		if (SUCCEEDED(hres))
		{	
			WORD wsz[MAX_PATH];
			// Set the path to the shell link target.
			hres = psl->SetPath(pszShortcutFile);
			// Set the description of the shell link.
			hres = psl->SetDescription(pszDesc);
			// Ensure string is ANSI.
			MultiByteToWideChar(CP_ACP, 0, pszLink, -1, wsz, MAX_PATH);
			// Save the link via the IPersistFile::Save method.
			hres = ppf->Save(wsz, TRUE);
			// Release pointer to IPersistFile.
			ppf->Release();
		}
		// Release pointer to IShellLink.
		psl->Release();
	}
	return hres;
}// CreateShortCut

// fXNgbvɃV[gJbg쐬
// file_name	: [IN] t@C̃tpX
void Create_ShortcutOnDesktop(char *file_name)
{
	char desktop_path[MAX_PATH];
	char shortcut_name[MAX_PATH];
	char shortcut_desc[MAX_PATH];
	char *p;
	
	CoInitialize(NULL);
	SHGetSpecialFolderPath(NULL, desktop_path, CSIDL_DESKTOPDIRECTORY, FALSE);
	GetFileTitle(file_name, shortcut_desc, MAX_PATH);
	p = strrchr(shortcut_desc, '.');
	if(p)
		strcpy(p, "");
	_snprintf(shortcut_name, MAX_PATH,"%s\\%s.lnk", desktop_path, shortcut_desc);
	strcat(shortcut_desc, "̺");
	if(GetFileAttributes(shortcut_name) == -1)
		CreateShortCut(file_name, shortcut_name, shortcut_desc);
	else
		MessageBox(GetFocus(), "޽į߂ɓ̼įĂ݂Ă܂", "", 0);
	CoUninitialize();
}// Create_ShortcutOnDesktop

#endif // __SHELLUTIL_H__
